local addonName, addon = ...

local UI_ERROR_MESSAGES_FOR_MOUNTED = { 
    ERR_ATTACK_MOUNTED,
    ERR_NOT_WHILE_MOUNTED,
    ERR_TAXIPLAYERALREADYMOUNTED,
    SPELL_FAILED_NOT_MOUNTED
};

local UI_ERROR_MESSAGES_FOR_SEATED = {
    ERR_CANTATTACK_NOTSTANDING,
    SPELL_FAILED_NOT_STANDING,
    ERR_LOOT_NOTSTANDING,
    ERR_TAXINOTSTANDING
};

local function isMountErrorMessage(msg)
    return tContains(UI_ERROR_MESSAGES_FOR_MOUNTED, msg);
end

local function isSeatedErrorMessage(msg)
    return tContains(UI_ERROR_MESSAGES_FOR_SEATED, msg);
end

local function printMsg(msg)
    print("|cffFF0000DismountOrStand:|r " .. msg);
end

local function addEventListeners(self)
    addon.frame:RegisterEvent("UI_ERROR_MESSAGE")
    addon.frame:RegisterEvent("TAXIMAP_OPENED")
end

local function onEvent(self, event, ...)
    local args = {...}
    
    if event == "UI_ERROR_MESSAGE" then
        local msg = args[2];

        if (isMountErrorMessage(msg)) then
            UIErrorsFrame:Clear();
            --printMsg("isMountedError")
            Dismount();
        end

        if (isSeatedErrorMessage(msg)) then
            UIErrorsFrame:Clear();
            --printMsg("isSeatedError")
            DoEmote("STAND");
        end

        return;
    end

    if event == "TAXIMAP_OPENED" then
        --printMsg("Taxi Map opened")
        Dismount();
        return;
    end
end

local function init()
    addon = {};
    addon.frame = CreateFrame("Frame");
    addon.frame:SetScript("OnEvent", onEvent);
    addEventListeners();
end

init();
